<?php

namespace Ems\Controllers;

use Exception\Messages;
use Service\LogService;
use Service\OAuth\OAuthCustomImpl;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;

use Ems\Services\TreinamentoService;

class TreinamentoController {

    /** @var TreinamentoService */
    protected $treinamentoService;
    
    public function __construct(EntityManager $entityManager, TreinamentoService $treinamentoService) {
        $this->entityManager        = $entityManager;
        $this->treinamentoService   = $treinamentoService;
    }
    
    public function getCurso(Request\Row $request, Response $response) {
        try {
            $params = $request->getRow();
            $dados = $this->treinamentoService->getCurso();
            $response->addDataSet(new DataSet('getCurso', $dados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
    
    public function getPerfilAcesso(Request\Row $request, Response $response) {
        try {
            $params = $request->getRow();
            $dados = $this->treinamentoService->getPerfilAcesso();
            $response->addDataSet(new DataSet('getPerfilAcesso', $dados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
    
    public function getMetodo(Request\Row $request, Response $response) {
        try {
            $params = $request->getRow();
            $dados = $this->treinamentoService->getMetodo();
            $response->addDataSet(new DataSet('getMetodo', $dados));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
}
